from typing import Dict, List

ROBOT: str = "nao"

LINK_NAMES: Dict[str, List[str]] = {
    "hrp4": ["l_sole", "r_sole", "torso", "body"],
    "nao": ["LSole", "RSole", "Torso", "base_link"],
}

REDUNDANT_DOFS: Dict[str, List[str]] = {
    "hrp4": [
        "NECK_Y",
        "NECK_P",
        "R_SHOULDER_P",
        "R_SHOULDER_R",
        "R_SHOULDER_Y",
        "R_ELBOW_P",
        "L_SHOULDER_P",
        "L_SHOULDER_R",
        "L_SHOULDER_Y",
        "L_ELBOW_P",
    ],
    "nao": [
        "HeadYaw",
        "HeadPitch",
        "LWristYaw",
        "LHand",
        "RWristYaw",
        "RHand",
    ],
}

INITIAL_CONFIG: Dict[str, Dict[str, float]] = {
    "hrp4": {
        "CHEST_P": 0.0,
        "CHEST_Y": 0.0,
        "NECK_P": 0.0,
        "NECK_Y": 0.0,
        "R_HIP_Y": 0.0,
        "R_HIP_R": -3.0,
        "R_HIP_P": -25.0,
        "R_KNEE_P": 50.0,
        "R_ANKLE_P": -25.0,
        "R_ANKLE_R": 3.0,
        "L_HIP_Y": 0.0,
        "L_HIP_R": 3.0,
        "L_HIP_P": -25.0,
        "L_KNEE_P": 50.0,
        "L_ANKLE_P": -25.0,
        "L_ANKLE_R": -3.0,
        "R_SHOULDER_P": 4.0,
        "R_SHOULDER_R": -8.0,
        "R_SHOULDER_Y": 0.0,
        "R_ELBOW_P": -25.0,
        "L_SHOULDER_P": 4.0,
        "L_SHOULDER_R": 8.0,
        "L_SHOULDER_Y": 0.0,
        "L_ELBOW_P": -25.0,
    },
    "nao": {
        "HeadYaw": 0.0,
        "HeadPitch": 0.0,
        "LHipYawPitch": 0.0,
        "LHipRoll": 0.0,
        "LHipPitch": 0.0,
        "LKneePitch": 0.0,
        "LAnklePitch": 0.0,
        "LAnkleRoll": 0.0,
        "LShoulderPitch": 90,
        "LShoulderRoll": 0.0,
        "LElbowYaw": 0.0,
        "LElbowRoll": 0.0,
        "LWristYaw": 0.0,
        "LHand": 0.0,
        "RHipYawPitch": 0.0,
        "RHipRoll": 0.0,
        "RHipPitch": 0.0,
        "RKneePitch": 0.0,
        "RAnklePitch": 0.0,
        "RAnkleRoll": 0.0,
        "RShoulderPitch": 90.0,
        "RShoulderRoll": 0.0,
        "RElbowYaw": 0.0,
        "RElbowRoll": 0.0,
        "RWristYaw": 0.0,
        "RHand": 0.0,
    },
}
